/*
 * @(#)Graph.java	1.9 99/08/04
 * MODIFS PYL juillet Aout 2005!!!!!!!!!!  octobre
 * www.lmm.jussieu.fr/~lagree
 + py@cccr.jussieu.fr
 *
 * This software is  designed and intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear facility.
 */
// 0107 bug Bi->1/Bi!!!!!!! 
 
//javac guiChalOmegaImp.java Kul.java kolor.java tridiago.java;java guiChalOmegaImp  
//javac guiChalOmegaImp.java Kul.java kolor.java tridiago.java; open index.html  

import java.util.*;
import java.awt.*;
import java.applet.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

import java.net.*;

 
class GraphPanel extends Panel
    implements Runnable, MouseListener {
    guiChalOmegaImp graph;
	Kul kkul=new Kul();
    public double dt0=0.000010;
   
	Thread relaxer;
	
	public GraphPanel (){
	}

    GraphPanel(guiChalOmegaImp graph) {
	this.graph = graph;
	addMouseListener(this);
    }

    void initout() {
    System.out.println("init t=" + kkul.t +" ....................... dt     =" +dt0);
	kkul.start();
	}
	
 
	 
	 	public void sauveparam()
    {   String texte = "#OK a poursuivre!";  
	    System.out.println("sauf" );
		
        try{
            FileOutputStream filename= new FileOutputStream("xy.dat");
            PrintStream ffile = new PrintStream(filename);
			for (int i = 0; i <= kkul.n; i++) {
                 ffile.println(i*kkul.dx + " " + kkul.T[i]);}
        }
        catch (IOException Ex)
        {System.out.println(Ex.getMessage());}
    } 

    public void run() {
        Thread me = Thread.currentThread();
	while (relaxer == me) {
	    relax();
	    try {
		Thread.sleep(200);
	    } catch (InterruptedException e) {
		break;
	    }
	}
    }

    synchronized void relax() {
	repaint();
    }

    
    Image offscreen;
    Dimension offscreensize;
    Graphics offgraphics;
 

    public synchronized void update(Graphics g) {
	    
      Dimension d = getSize();
      if ((offscreen == null) || (d.width != offscreensize.width) || (d.height != offscreensize.height)) {
	    offscreen = createImage(d.width, d.height);
	    offscreensize = d;
	    if (offgraphics != null) {
	        offgraphics.dispose();
	    }
	    offgraphics = offscreen.getGraphics();
	    offgraphics.setFont(getFont());
	}

	offgraphics.setColor(getBackground());
	offgraphics.fillRect(0, 0, d.width, d.height);
	offgraphics.setColor(Color.black) ;
	offgraphics.drawLine(d.width/4,  d.height*8/10,(3*d.width)/4 ,  d.height*8/10);
	offgraphics.drawLine(d.width/4,  d.height*8/10,d.width/4 , d.height*3/10);
	offgraphics.drawLine((3*d.width)/4,  d.height*8/10,(3*d.width)/4 , d.height*3/10);
	offgraphics.drawLine(d.width/4,  d.height*3/10,(3*d.width)/4, d.height*3/10);
	offgraphics.drawString("x " ,  4*d.width/5, d.height*8/10);
	offgraphics.drawString("T(x,t="+(((int)(kkul.t*1000))/1000.)+")",  d.width/8, d.height/8);	
	offgraphics.setColor(Color.red) ;
	for (int i = 1 ; i <= kkul.n ; i++) {
	    offgraphics.drawLine(d.width/4+(i-1)*d.width/kkul.n/2, d.height*8/10-(int)(d.height*kkul.T[i-1]/2),
		                     d.width/4+   i* d.width/kkul.n/2, d.height*8/10-(int)(d.height*kkul.T[ i ]/2));
	}
	
	
	for (int i = 1 ; i <= kkul.n ; i++) {
    offgraphics.setColor(kolor.code(kkul.T[i]));	 
	offgraphics.fillRect(d.width/4+(i)*d.width/kkul.n/2, d.height*8/10-(int)(d.height*(1.4/2)),
		                          (1+d.width/kkul.n/2),  d.height/10);					 
	}
	
	g.drawImage(offscreen, 0, 0, null);
    }
 
	 
    //1.1 event handling
    public void mouseClicked(MouseEvent e) {}
    public void mousePressed(MouseEvent e) {
	if(((e.getX()<getSize().width/4))&&(e.getY()<getSize().height*8/10)&&(e.getY()>getSize().height*3/10)) 
	    {kkul.T0=-(e.getY()-getSize().height*8/10)*2.0/(getSize().height);System.out.println("g "+ kkul.T0);     }   
	if(((e.getX()>3*getSize().width/4))&&(e.getY()<getSize().height*8/10)&&(e.getY()>getSize().height*3/10)) 
	    {kkul.T1=-(e.getY()-getSize().height*8/10)*2.0/(getSize().height);System.out.println("d "+ kkul.T1);     }  
	if((e.getX()>getSize().width/4)&&(e.getX()<3*getSize().width/4)){
	    kkul.T[(e.getX()-getSize().width/4)*2*kkul.n/(getSize().width)]=-(e.getY()-getSize().height*8/10)*2.0/(getSize().height);
		System.out.println("pressed "+e.getX()+" "+e.getY()+" " +getSize().width/4/(getSize().width/kkul.n/2));}}
    public void mouseReleased(MouseEvent e){}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e)  {}
    public void mouseDragged(MouseEvent e) {}
    public void mouseMoved(MouseEvent e)   {}
	
    public void start() {
	relaxer = new Thread(this);
	relaxer.start();
	}

    public void stop() {
	relaxer = null;
    }

}
 
public class guiChalOmegaImp extends Applet  implements ActionListener, ItemListener {
	public AudioClip sound0=null;
    GraphPanel panel;
    Panel controlPanel;
	
    
	JButton raz    = new JButton("RAZ"); 
    JButton calcul = new JButton("Calcul");
    JButton pause  = new JButton("Pause");
	JButton kit = new JButton("Quitte");
	//JSlider sliderR = new JSlider(JSlider.HORIZONTAL, 0, 250, 180);
	
    JLabel lab = new JLabel("<html><font size=\"10\" color=\"red\">gros coucou rouge</font><br><b>et ligne en italique gras<i></b></i></html>  ", JLabel.CENTER) ; 
	JTextField saizie= new JTextField ("0.000010"); 
	Choice choix = new Choice();
	JLabel labo = new JLabel("                   ", JLabel.CENTER) ; 
	JTextField saizio= new JTextField ("0.000");

    public void init() {
	 try {
     sound0 = getAudioClip(new URL(getCodeBase(), "bouteille.au"));
     sound0.play();
	  }
	  catch (Exception e) {System.out.println( e);}

//	sound0 = getAudioClip(getCodeBase(), "drip.au");
//	sound0 = getAudioClip("file:///Users/pyl/Desktop/Appliquette-JavaChal/guiChalomega_v_implicite/drip.au");	
	setLayout(new BorderLayout()); 
	panel = new GraphPanel(this);
	add("Center", panel);
	
	 
	controlPanel = new Panel();
	add("South", controlPanel);
    //controlPanel.add(sliderR);
    controlPanel.add(lab) ;   lab.setText("  dt=   ") ;
	controlPanel.add(saizie);
	 raz.setLocation(10,10);raz.setSize(220,23); controlPanel.add(raz);  raz.addActionListener(this);
	controlPanel.add(calcul); calcul.addActionListener(this);
	controlPanel.add(pause);  pause.addActionListener(this);
	String champ="T imp....";
	controlPanel.add(labo) ;  labo.setText(champ) ;
    controlPanel.add(saizio);
	controlPanel.add(new JLabel("Cond. lim.", Label.RIGHT));       
        choix.addItemListener(this);
        controlPanel.add(choix);
        choix.addItem("T(0)=0, T(1)=0         ");//0
        choix.addItem("T(0)=0, T(1)=1         "); 
		choix.addItem("T(0)=1, T(1)=0         "); 
        choix.addItem("T(0)=1, T(1)=1         ");//3
        choix.addItem("T(0)=1, T'(1)=0        ");
        choix.addItem("T(0)=0, T'(1)=0        ");
        choix.addItem("T(0)=sin(om t),T(1)=0  ");//6
        choix.addItem("T(0)=sin(om t),T'(1)=0 ");
        choix.addItem("T'(0)=-q, T(1)=0       ");
        choix.addItem("T'(0)=-q, T'(1)=0      ");//9
        choix.addItem("T'(0)=Bi T(0),T(1)=1   ");
        choix.addItem("T'(0)=Bi T(0),T'(1)=0   ");
	controlPanel.add(kit);    kit.addActionListener(this);
	panel.initout();
	
	
	}

    public void destroy() {
        remove(panel);
        remove(controlPanel);
    }

    public void start() {
	razz(); 
	panel.start();
	}
	

    public void stop() {
	panel.stop();
    }
	
	
	public void razz() {
	 panel.kkul.prems();
	 	 synchronized (panel.kkul) {
		 panel.kkul.pleaseWait = true;}
	 change_it(); 
	 System.out.println("Init" );
	     }

    public void actionPerformed(ActionEvent e) {
		Object src = e.getSource();
	if (src == raz) { 
	    razz(); 
    	System.out.println("RAZ, t=" + panel.kkul.t);
		sound0.play();
		return;
	}
	
	if (src == calcul) { 
	    String ch=saizie.getText();
		double z =Double.parseDouble(ch);  
	    System.out.println("calcul, t=" + panel.kkul.t + "................dt =" + z );
	    panel.kkul.setdt(z);  
	    change_it();
		
        synchronized (panel.kkul) {
            panel.kkul.pleaseWait = false;
            panel.kkul.notify();}
		return;
	}

	if (src == pause) {
		 synchronized (panel.kkul) {
		 panel.kkul.pleaseWait = true;}
		 panel.sauveparam(); 
	    	}
	if (src == kit) {
		  destroy(); 
		  System.out.println("kenavo"); 
		  System.exit(0) ;
	    	}		
    }

    public void itemStateChanged(ItemEvent e) {
	 change_it();
	    }

   public void change_it(){
   int ined=choix.getSelectedIndex(); 
	String ch=saizie.getText();
	double z =Double.parseDouble(ch); 
    ch=saizio.getText();
	z =Double.parseDouble(ch); 
	System.out.println("param  " +  z  );
		
	if (ined==0 ){panel.kkul.cl00(); labo.setText("T imp....") ;}
	if (ined==1 ){panel.kkul.cl01(); labo.setText("T imp....") ;}
	if (ined==2 ){panel.kkul.cl10(); labo.setText("T imp....") ;}
	if (ined==3 ){panel.kkul.cl11(); labo.setText("T imp....") ;}	
	if (ined==4 ){panel.kkul.cl1s(); labo.setText("T imp.sym") ;}
	if (ined==5 ){panel.kkul.cl0s(); labo.setText("T imp.sym") ;}
	if (ined==6 ){panel.kkul.omega=z;panel.kkul.clt0(); labo.setText("omega=   ");}
	if (ined==7 ){panel.kkul.omega=z;panel.kkul.clts(); labo.setText("omega=   ");}
	if (ined==8 ){panel.kkul.q=z;    panel.kkul.clq1(); labo.setText("q=     ") ;}
	if (ined==9 ){panel.kkul.q=z;    panel.kkul.clqs(); labo.setText("q=     ") ;}
	if (ined==10){panel.kkul.Bi=z;   panel.kkul.clB1(); labo.setText("1/Bi=  ") ;}
	if (ined==11){panel.kkul.Bi=z;   panel.kkul.clBs(); labo.setText("1/Bi=  ") ;}
   }
   
	
///////////////////////////////////////////////////////////
	public static void main(String args[]) {
	JFrame f = new JFrame("guiChaleur Implicite par PYL");
	guiChalOmegaImp guiChalOmegaImp = new guiChalOmegaImp();
	//System.out.println(args[]);

	guiChalOmegaImp.init();
	guiChalOmegaImp.start();
	
	f.getContentPane().add("Center", guiChalOmegaImp);
	f.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE ) ;
	f.setSize(840, 400);
	f.setLocation(200, 200);
	f.show();
    }

    public String getAppletInfo() {
        return "Calcul interactif par PYL. \n 'java guiGraph' \nou applet.";
    }

}